#include <winsock2.h>
#include <windows.h>
#include <tchar.h>

#pragma comment(lib,"ws2_32.lib")

#define IDC_EDIT_IN		    101
#define IDC_EDIT_OUT		102
#define IDC_BUTTON_SEND		103
#define IDC_BUTTON_RUN      104
#define IDC_EDIT_PORT		105
#define IDC_STATIC		    106

HWND hEditIn = NULL;
HWND hEditOut = NULL;
HWND hButton = NULL;
SOCKET listenSocket = INVALID_SOCKET;
SOCKET connectionSocket = INVALID_SOCKET;
HANDLE hThread;
BOOL serwerDziala = FALSE;

#define ROZMIAR_BUFORA  1024

LRESULT CALLBACK WinProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);

/* Funkcja pomoznicza dodajaca tekst na koncu kontrolki edycyjnej.*/
void DodajKomunikat(HWND hEdit, TCHAR *tekst)
{
	TCHAR buf[ROZMIAR_BUFORA+2];
	int index = GetWindowTextLength(hEdit);
	_tcscpy_s(buf, ROZMIAR_BUFORA, tekst);
	_tcscat_s(buf, ROZMIAR_BUFORA, TEXT("\r\n"));
	SetFocus(hEdit);
	SendMessage(hEdit, EM_SETSEL, (WPARAM)index, (LPARAM)index);
	SendMessage(hEdit, EM_REPLACESEL, 0, (LPARAM)buf);
}

int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpCmdLine, int nShowCmd)
{
	WNDCLASSEX wClass;
	ZeroMemory(&wClass, sizeof(WNDCLASSEX));
	wClass.cbSize = sizeof(WNDCLASSEX);
	wClass.hbrBackground = (HBRUSH)COLOR_WINDOW;
	wClass.hCursor = LoadCursor(NULL, IDC_ARROW);
	wClass.hInstance = hInst;
	wClass.lpfnWndProc = (WNDPROC)WinProc;
	wClass.lpszClassName = TEXT("Window Class");
	wClass.style = CS_HREDRAW | CS_VREDRAW;

	if (!RegisterClassEx(&wClass))
	{
		MessageBox(NULL, TEXT("Window class creation failed"), TEXT("Window Class Failed"), MB_ICONERROR);
		return 1;
	}

	HWND hWnd = CreateWindow(
		TEXT("Window Class"),
		TEXT("Serwer"),
		WS_OVERLAPPEDWINDOW,
		200,
		200,
		335,
		480,
		NULL,
		NULL,
		hInst,
		NULL);

	if (!hWnd)
		MessageBox(NULL, TEXT("Window creation failed"), TEXT("Window Creation Failed"), MB_ICONERROR);

	ShowWindow(hWnd, nShowCmd);

	MSG msg;
	ZeroMemory(&msg, sizeof(MSG));

	while (GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return 0;
}

/* 	Watek serwera oczekujacy na nowe polaczenia i odpowiedzalny z komunikacje z klientem. */
DWORD ServerThread(LPVOID dane)
{
	SOCKET *socket = (SOCKET*)dane;
	char tekst[ROZMIAR_BUFORA];
	TCHAR tekst2[ROZMIAR_BUFORA];

	DodajKomunikat(hEditIn, TEXT("Czekam na nowe poaczenie"));

	connectionSocket = accept(*socket, NULL, NULL);
	if (connectionSocket == INVALID_SOCKET) {
		DodajKomunikat(hEditIn, TEXT("Bd funkcji accept()"));

		closesocket(*socket);
		serwerDziala = FALSE;
		return 1;
	}
	
	DodajKomunikat(hEditIn, TEXT("Hura!!!! Jestem poczony!"));

	EnableWindow(hEditOut, TRUE);
	EnableWindow(hButton, TRUE);

	while(1)
	{
		int n = 0;
		ZeroMemory(tekst, sizeof(tekst));

		n = recv(connectionSocket, (char *)tekst, sizeof(tekst), 0);
		MultiByteToWideChar(CP_UTF8, 0, tekst, -1, tekst2, ROZMIAR_BUFORA);
		if (n > 0) DodajKomunikat(hEditIn, (TCHAR*)tekst2);
		else
		{
			DodajKomunikat(hEditIn, TEXT("Poczenie zerwane"));
			break;
		}
	}
	DodajKomunikat(hEditIn, TEXT("Koniec dziaania wtku serwera"));
	closesocket(listenSocket);
	listenSocket = INVALID_SOCKET;
	serwerDziala = FALSE;

	EnableWindow(hEditOut, FALSE);
	EnableWindow(hButton, FALSE);

}

LRESULT CALLBACK WinProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch (msg)
	{
	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDC_BUTTON_RUN:
		{
			TCHAR komunikat[ROZMIAR_BUFORA];

			if (serwerDziala == FALSE)
			{
				// Proba uruchomienia watka serwera
				int nPort = 0;
				TCHAR portstr[100];
				SOCKADDR_IN adres;

				if (!GetDlgItemText(hWnd, IDC_EDIT_PORT, portstr, 100)) portstr[0] = TEXT('\0');
				else nPort = _ttoi(portstr);

				_stprintf_s(komunikat, ROZMIAR_BUFORA, TEXT("Prba pocznia na porcie %d"), nPort);
				DodajKomunikat(hEditIn, komunikat);

				listenSocket = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
				if (listenSocket == INVALID_SOCKET) {
					MessageBox(hWnd, TEXT("Bd tworzenia gniazda (socket)"), TEXT("Error"), MB_OK);
					break;
				}

				adres.sin_port = htons(nPort);
				adres.sin_family = AF_INET;
				adres.sin_addr.s_addr = htonl(INADDR_ANY);

				if (bind(listenSocket, (SOCKADDR*)&adres, sizeof(adres)) == SOCKET_ERROR)
				{
					MessageBox(hWnd, TEXT("Bd funkcji bind()"), TEXT("Error"), MB_OK);
					closesocket(listenSocket);
					break;
				}

				if (listen(listenSocket, 1) == SOCKET_ERROR)
				{
					MessageBox(hWnd, TEXT("Bd funkcji listen()"), TEXT("Error"), MB_OK);
					closesocket(listenSocket);
					break;
				}

				hThread = CreateThread(NULL, 0,
					(LPTHREAD_START_ROUTINE)ServerThread, &listenSocket, 0, NULL);
				
				if (hThread == NULL)
				{
					MessageBox(hWnd, TEXT("Bd tworzenia wtku"), TEXT("Error"), MB_OK);
					closesocket(listenSocket);
					break;
				}
				
				SetWindowText(GetDlgItem(hWnd, IDC_BUTTON_RUN), TEXT("Stop"));
				serwerDziala = TRUE;
			}
			else
			{
				closesocket(listenSocket);
				listenSocket = INVALID_SOCKET;
				serwerDziala = FALSE;
				
				DodajKomunikat(hEditIn, TEXT("Zamykam serwer"));
				SetWindowText(GetDlgItem(hWnd, IDC_BUTTON_RUN), TEXT("Run"));
			}
			break;
		}
		case IDC_BUTTON_SEND:
		// Send message to client
		{
			int n = 0;
			TCHAR tekst[ROZMIAR_BUFORA];
			ZeroMemory(tekst, sizeof(tekst));
			GetWindowText(hEditOut, tekst, ROZMIAR_BUFORA);
			n = send(connectionSocket, (char*)tekst, (_tcslen(tekst) +1 )* sizeof(TCHAR) , 0);
			if (n == SOCKET_ERROR)
				DodajKomunikat(hEditIn, TEXT("Bd wysyania!"));
			DodajKomunikat(hEditIn, tekst);
			SetWindowText(hEditOut, TEXT(""));
			break;
		}
	}
	break;
	case WM_CREATE:
	{
		WSADATA WsaDat;
		HGDIOBJ hfDefault;
					  
		CreateWindow(TEXT("STATIC"), TEXT("Port: "),
			WS_CHILD | WS_VISIBLE ,
			10, 10, 30, 23, hWnd, (HMENU)IDC_STATIC,  GetModuleHandle(NULL),  NULL);

		CreateWindow(TEXT("EDIT"), TEXT("1234"),
			WS_CHILD | WS_VISIBLE | WS_BORDER,
			40, 10, 50, 23, hWnd, (HMENU)IDC_EDIT_PORT, GetModuleHandle(NULL), NULL);
					 
		CreateWindow(TEXT("BUTTON"), TEXT("Run"),
			WS_TABSTOP | WS_VISIBLE | WS_CHILD | BS_DEFPUSHBUTTON,
			110, 10, 175, 23,
			hWnd,
			(HMENU)IDC_BUTTON_RUN,
			GetModuleHandle(NULL),
			NULL);

		// Create incoming message box
		hEditIn = CreateWindowEx(WS_EX_CLIENTEDGE,
			TEXT("EDIT"), TEXT("Serwer nie jest uruchomiony.\r\n"),
			WS_CHILD | WS_VISIBLE | ES_MULTILINE | ES_AUTOVSCROLL | ES_AUTOHSCROLL,
			10, 50, 300, 300,
			hWnd, 
			(HMENU)IDC_EDIT_IN,
			GetModuleHandle(NULL),
			NULL);
			
		if (!hEditIn)  MessageBox(hWnd, TEXT("Bad tworzenia kontrolki edit"), TEXT("Error"), MB_OK | MB_ICONERROR);
					  
		// Create outgoing message box
		hEditOut = CreateWindowEx(WS_EX_CLIENTEDGE,
			TEXT("EDIT"), TEXT("Tutaj wpisz komunikat..."),  WS_CHILD | WS_VISIBLE | ES_MULTILINE |
			ES_AUTOVSCROLL | ES_AUTOHSCROLL ,
			10, 360, 220, 60, hWnd,
			(HMENU)IDC_EDIT_OUT,
			GetModuleHandle(NULL),
			NULL);
					  
		if (!hEditOut) MessageBox(hWnd, TEXT("Bad tworzenia kontrolki edit."), TEXT("Error"),  MB_OK | MB_ICONERROR);
					  
		// Create a push button
		hButton = CreateWindow(
			TEXT("BUTTON"),
			TEXT("Send"),
			WS_TABSTOP | WS_VISIBLE |
			WS_CHILD | BS_DEFPUSHBUTTON ,
			240, 360, 60, 60,
			hWnd,
			(HMENU)IDC_BUTTON_SEND,
			GetModuleHandle(NULL),
			NULL);

		EnableWindow(hEditOut, FALSE);
		EnableWindow(GetDlgItem(hWnd, IDC_BUTTON_SEND), FALSE);

		if (WSAStartup(MAKEWORD(2, 2), &WsaDat) != 0)
		{
			MessageBox(hWnd, TEXT("Bd podczs inicjalizacji Winsock"), TEXT("Critical Error"), MB_ICONERROR);
			SendMessage(hWnd, WM_DESTROY, 0, 0);
			break;
		}

		hfDefault = GetStockObject(DEFAULT_GUI_FONT);
		SendMessage(GetDlgItem(hWnd, IDC_EDIT_PORT), WM_SETFONT, (WPARAM)hfDefault, MAKELPARAM(FALSE, 0));
		SendMessage(GetDlgItem(hWnd, IDC_STATIC), WM_SETFONT, (WPARAM)hfDefault, MAKELPARAM(FALSE, 0));
		SendMessage(hEditOut, WM_SETFONT, (WPARAM)hfDefault, MAKELPARAM(FALSE, 0));
		SendMessage(hEditIn, WM_SETFONT, (WPARAM)hfDefault, MAKELPARAM(FALSE, 0));
		SendMessage(hButton, WM_SETFONT, (WPARAM)hfDefault, MAKELPARAM(FALSE, 0));
		SendMessage(GetDlgItem(hWnd, IDC_BUTTON_RUN), WM_SETFONT, (WPARAM)hfDefault, MAKELPARAM(FALSE, 0));
	}
	break;

	case WM_DESTROY:
	{
		PostQuitMessage(0);
		WSACleanup();
		return 0;
	}
	break;
	}

	return DefWindowProc(hWnd, msg, wParam, lParam);
}